package com.zipcodewilmington.phonebook;

import com.zipcodewilmington.phonebook.PhoneBook;
import org.junit.Assert;
import org.junit.Test;

public class PhoneBookTest
{
    private static final int Expected = 0;


    @Test
    public void testHasEntry() {
        //Given
        PhoneBook book = new PhoneBook();
        String name = "Kaitlyn";
        String phoneNumber = "302-345-3333";
        book.hasEntry(name);
        //When
        boolean actualOutput = book.hasEntry(name);
        //Then
        Assert.assertEquals(true,actualOutput);
    }

    @Test
    public void testAdd(){
        //Given
        PhoneBook book = new PhoneBook();
        String name = "Romeo";
        String phoneNumber = "302-234-2222";

        //When
        //book.add(name, phoneNumber);
        String actualOutput = book.add(name, phoneNumber);
        //Then
        Assert.assertEquals(null, actualOutput);
    }

    @Test
    public void testLookup()
    {
        //Given
        PhoneBook book = new PhoneBook();
        String name = "Adam";
        String phoneNumber = "201-999-3333";

        String actualOutput=book.lookup(name);

        Assert.assertEquals(phoneNumber, actualOutput);
    }

    @Test
    public void testLookup_forMultipleEntries()
    {
        //Given
        PhoneBook book = new PhoneBook();
        book.add("name1", "302");
        book.add("name2", "201");

        String name = "Kaitlyn";
        String phoneNumber = "302-345-3333";

        //book.lookup(name);
        String actualOutput=book.lookup(name);

        Assert.assertEquals(actualOutput ,phoneNumber );
    }
    @Test
    public void testRemove()
    {
        PhoneBook  book= new PhoneBook();
        String expectedname="Romeo";
        String name="Romeo";


        String actualOutput=book.hasRemove(name);
        Assert.assertEquals(actualOutput,name);

    }
    @Test
    public void testReserveLookup()
    {
        PhoneBook  book= new PhoneBook();
        String name="Kaitlyn";
        String phoneNumber = book.lookup(name);
        String actualOutput = book.reverseLookup(phoneNumber);

        Assert.assertEquals(name,actualOutput);
    }

    @Test
    public void testListNamesandNumbers()
    {
        PhoneBook  book= new PhoneBook();
        book.clearSortedMap();
        book.add("Romeo", "302-234-2222");
        book.add("Kaitlyn", "302-345-3333");
        String expected = "Kaitlyn 302-345-3333 \nRomeo 302-234-2222\n";
        String actualOutput= book.listNamesAndNumbers();
        Assert.assertEquals(expected, actualOutput);
    }
}